﻿using System;
using System.Text.RegularExpressions;

public partial class _Default : System.Web.UI.Page
{
    /// <summary>
    /// Page load event
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            lblTotalCharCount.Text = "0";
            lblCharCountWithoutWhitespace.Text = "0";
            lblWordCount.Text = "0";
            lblLineCount.Text = "0";
        }
    }
   
    /// <summary>
    /// Count 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnCount_Click(object sender, EventArgs e)
    {
        //Total Char Count
        lblTotalCharCount.Text = CountTotalChars(txtCharInput.Text).ToString(); ;

        //Char Count Without Whitespace
        lblCharCountWithoutWhitespace.Text = CountCharsWithoutWhitespace(txtCharInput.Text).ToString();

        //Word Count
        lblWordCount.Text = WordCount(txtCharInput.Text).ToString();

        //Line Count
        lblLineCount.Text = LineCount(txtCharInput.Text).ToString();


    }
    /// <summary>
    /// Clear Text
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnClear_Click(object sender, EventArgs e)
    {
        txtCharInput.Text = "";
        btnCount_Click(null, null);
    }

    /// <summary>
    /// Count Total Chars
    /// </summary>
    /// <param name="strInput"></param>
    /// <returns></returns>
    private long CountTotalChars(string strInput)
    {
        long intCount = 0;
        
        foreach (char ch in strInput)
        {                
           intCount++;                            
        }
        return intCount;
    }

    /// <summary>
    /// Count Chars Without Whitespace
    /// </summary>
    /// <param name="strInput"></param>
    /// <returns></returns>
    private long CountCharsWithoutWhitespace(string strInput)
    {
        long intCount = 0;
        
        foreach (char ch in strInput)
        {
            if(!char.IsWhiteSpace(ch))
                intCount++;                
            
        }
        return intCount;
    }

    /// <summary>
    /// Word Count
    /// </summary>
    /// <param name="strInput"></param>
    /// <returns></returns>
    private long WordCount(string strInput)
    {
        long intCount = 0;
        for (int i = 1; i < strInput.Length; i++)
        {
            if (char.IsWhiteSpace(strInput[i - 1]) == true)
            {
                if (char.IsLetterOrDigit(strInput[i]) == true ||
                    char.IsPunctuation(strInput[i]))
                {
                    intCount++;
                }
            }
        }
        if (strInput.Length > 2)
        {
            intCount++;
        }
        return intCount;
    }

    /// <summary>
    /// Line Count
    /// </summary>
    /// <param name="strInput"></param>
    /// <returns></returns>
    private long LineCount(string strInput)
    {        
        Regex regxNewLine = new Regex("\n", RegexOptions.Multiline);
        MatchCollection objMatchCollection = regxNewLine.Matches(strInput);
        
        return objMatchCollection.Count + 1;
    }
}
